pipeline {
    agent any

    
    environment {
      //registry = '172.20.14.188:18082/api-demo'
      //registryCredential = 'jenkinsdocker'
      //pipelineGitCredential = 'gitlab-pipeline-token'
      //pipelineGitUrl = 'git.g-able.com/baaclos/pipeline-cicd.git'
      dockerImage = ''
      appName = ''
      currentPomVersion = ''
      newVersion = ''
    }


    stages {

        stage('Prepare configuration') {
        steps {
            script {
                withCredentials([string(credentialsId: "${pipelineGitCredential}", variable: 'token')]){
                    // clone cicd template repo
                    sh "git clone https://jenkins:${token}@${pipelineGitUrl}"
                    // copy ci files from cicd template repo to local
                    sh "cp -a pipeline-cicd/springboot/dev/. ."
                }

                sh 'rm -rf pipeline-cicd'

                gitUrl =  scm.getUserRemoteConfigs()[0].getUrl().substring(8)
                def pom = readMavenPom file: 'pom.xml'
                appName = pom.name   
                // def props = readProperties  file: 'src/main/resources/application.properties'

                def (major, miner, build) = pom.version.tokenize('.')
                currentPomVersion = "${major}.${miner}.${build}"
                newVersion = "${major}.${miner}." + (build.toInteger() + 1)

                sh "sed -i \'0,/${currentPomVersion}/s//${newVersion}/\' pom.xml"

                // authorName = sh (
                //     script: 'git --no-pager show -s --format=\'%an\'',
                //     returnStdout: true
                // ).trim()

                // authorEmail = sh (
                //     script: 'git --no-pager show -s --format=\'%ae\'',
                //     returnStdout: true
                // ).trim()
            }
        }
        
        }

        stage('Build') {
            steps {
                sh 'mvn -B -DskipTests clean package'
            }
        }
        stage('Test') {
            steps {
                sh 'mvn test'
            }
            post {
                always {
                    junit 'target/surefire-reports/*.xml'
                }
            }
        }
        stage('Build image') {
            steps {
                script {
                    dockerImage = docker.build("zarb007/test-buildimage01")
                }
            }
        }
        stage('Push image') {
            steps {
                script {
                    withDockerRegistry(
                        credentialsId: 'docker-credential',
                        url: 'https://index.docker.io/v1/') {
                        dockerImage.push("$BUILD_NUMBER")
                        dockerImage.push()
                    }
                }
            }
        }
        /*stage('Deployment') {
            steps {
                sh 'kubectl apply -f deployment.yml';
            }
        }*/
    }
}

